--------------------------------
-- FACING WORLDS
--------------------------------

--0.2
-- added some weapons to the weaponset (parachute + firepunch, I think)
-- everything else I don't remember

-- 0.3
-- removed basketball code
-- removed some other stuff
-- fixed girder rotation limitation
-- lazypasted circles for teleport exit

-- 0.4
-- nerfed parachute

--------------------------------

loadfile(GetDataPath() .. "Scripts/Locale.lua")()
loadfile(GetDataPath() .. "Scripts/Tracker.lua")()

local numhhs = 0
local hhs = {}

local numTeams
local teamNameArr = {}
local teamSize = {}
local teamIndex = {}

--------------
--------------

local vCirc = {}
local vCircX = {}
local vCircY = {}
local vCircMinA = {}
local vCircMaxA = {}
local vCircType = {}
local vCircPulse = {}
local vCircFuckAll = {}
local vCircRadius = {}
local vCircWidth = {}
local vCircCol = {}

--------------------------------
--zone and teleporter variables
--------------------------------

local actionReset = 0 -- used in CheckTeleporters()
local effectTimer = 0

local redTel
local orangeTel
local fCol = {}

local zXMin = {}
local zWidth = {}
local zYMin = {}
local zHeight = {}
local zOccupied = {}
local zCount = 0

function ManageTeleporterEffects()
	effectTimer = effectTimer + 1
	if effectTimer > 50 then
		effectTimer = 0

		for i = 0,1 do
			eX = 10 + zXMin[i] + GetRandom(zWidth[i]-10)
			eY = 50 + zYMin[i] + GetRandom(zHeight[i]-110)

			tempE = AddVisualGear(eX, eY, vgtDust, 0, false)
			g1, g2, g3, g4, g5, g6, g7, g8, g9, g10 = GetVisualGearValues(tempE)
			SetVisualGearValues(tempE, eX, eY, g3, g4, g5, g6, g7, g8, g9, fCol[i])
		end
	end
end

function CreateZone(xMin, yMin, width, height)


	zXMin[zCount] = xMin
	zYMin[zCount] = yMin
	zWidth[zCount] = width
	zHeight[zCount] = height
	zOccupied[zCount] = false
	zCount = zCount + 1

	return (zCount-1)

end

function GearIsInZone(gear, zI)

	if (GetX(gear) > zXMin[zI]) and (GetX(gear) < (zXMin[zI]+zWidth[zI])) and (GetY(gear) > zYMin[zI]) and (GetY(gear) < (zYMin[zI]+zHeight[zI])) then
		zOccupied[zI] = true
	else
		zOccupied[zI] = false
	end

	return zOccupied[zI]

end

function CheckTeleporters()

	teleportActive = false

	if (GearIsInZone(CurrentHedgehog, redTel) == true) and (GetHogClan(CurrentHedgehog) == 0) then
		teleportActive = true
		destinationX = 1999
		destinationY = 1822
	elseif (GearIsInZone(CurrentHedgehog, orangeTel) == true) and (GetHogClan(CurrentHedgehog) == 1) then
		teleportActive = true
		destinationX = 2180
		destinationY = 1822
	end

	if teleportActive == true then
		if actionReset == 20 then
			AddVisualGear(GetX(CurrentHedgehog), GetY(CurrentHedgehog), vgtBigExplosion, 0, false)
			SetGearPosition(CurrentHedgehog,destinationX,destinationY)
			AddVisualGear(GetX(CurrentHedgehog), GetY(CurrentHedgehog), vgtBigExplosion, 0, false)
		end

		actionReset = actionReset + 1
		if actionReset >= 30 then
			actionReset = 0
		end

	end

end


function RebuildTeamInfo()

	for i = 0, 5 do
		teamNameArr[i] = i
		teamSize[i] = 0
		teamIndex[i] = 0
	end
	numTeams = 0

	for i = 0, (numhhs-1) do

		z = 0
		unfinished = true
		while(unfinished == true) do

			newTeam = true
			tempHogTeamName = GetHogTeamName(hhs[i])

			if tempHogTeamName == teamNameArr[z] then
				newTeam = false
				unfinished = false
			end

			z = z + 1

			if z == TeamsCount then
				unfinished = false
				if newTeam == true then
					teamNameArr[numTeams] = tempHogTeamName
					numTeams = numTeams + 1
				end
			end

		end

	end

	-- find out how many hogs per team, and the index of the first hog in hhs
	for i = 0, numTeams-1 do

		for z = 0, numhhs-1 do
			if GetHogTeamName(hhs[z]) == teamNameArr[i] then
				if teamSize[i] == 0 then
					teamIndex[i] = z -- should give starting index
				end
				teamSize[i] = teamSize[i] + 1
				--add a pointer so this hog appears at i in hhs
			end
		end

	end

end

-----------
-----------
-----------
-----------
-----------
-----------
-----------
-----------
-----------
-----------
-----------
-----------

function onGameInit()

	GameFlags = gfDivideTeams + gfResetWeps + gfDisableWind + gfInfAttack
	TurnTime = 20000
	CaseFreq = 0
	MinesNum = 0
	MinesTime  = 2000
	Explosives = 0
	Delay = 10
	SuddenDeathTurns = 99999
	--Map = "FacingWorlds"
	Theme = "Snow"

end

function onGameStart()

	ShowMission(loc("FACING WORLDS"), loc("Time to improvise!"), loc("- Weapons are reset at the end of your turn|- Using a weapon doesn't end your turn"), -amGrenade, 0)

	xOffSet = 950
	yOffSet = 125-400
													--449
	redTel = CreateZone(342+xOffSet,1330 + yOffSet,45,849)	-- red teleporter
	orangeTel = CreateZone(3719-xOffSet,1330 +yOffSet,45,849)	-- orange teleporter

	-- Get Clan Colour for teleporters
	for i = 0, 1 do
		fCol[i] = GetClanColor(i)
	end


	trackTeams()
	runOnHogs(FlipIt)

	-----------
	-- lazy paste
	-----------
	RebuildTeamInfo()
	team1Placed = 0
	team2Placed = 0
	for i = 0, (TeamsCount-1) do
		for g = teamIndex[i], (teamIndex[i]+teamSize[i]-1) do
			if GetHogClan(hhs[g]) == 0 then
				SetGearPosition(hhs[g],1403+ ((team1Placed+1)*75),1822)
				team1Placed = team1Placed +1
				if team1Placed > 6 then
					team1Placed = 0
				end
			elseif GetHogClan(hhs[g]) == 1 then
				SetGearPosition(hhs[g],2691- ((team2Placed+1)*75),1822)
				team2Placed = team2Placed +1
				if team2Placed > 6 then
					team2Placed = 0
				end
			end
		end
	end
	----------
	----------
	vCircX[0], vCircY[0] = 1999, 1822
	vCircX[1], vCircY[1] = 2180, 1822

	for i = 0, 1 do
		vCirc[i] = AddVisualGear(0,0,vgtCircle,0,true)
		vCircMinA[i] = 20
		vCircMaxA[i] = 255
		vCircType[i] = 1
		vCircPulse[i] = 10
		vCircFuckAll[i] = 0
		vCircRadius[i] = 300
		vCircWidth[i] = 5
		vCircCol[i] = fCol[i]
		SetVisualGearValues(vCirc[i], vCircX[i], vCircY[i], vCircMinA[i], vCircMaxA[i], vCircType[i], vCircPulse[i], vCircFuckAll[i], vCircRadius[i], vCircWidth[i], vCircCol[i])
	end

end

function InputMaskThatGuy()

	if GetHogClan(CurrentHedgehog) == 0 then
		SetInputMask(band(0xFFFFFFFF, bnot(gmRight)))
	else
		SetInputMask(band(0xFFFFFFFF, bnot(gmLeft)))
	end

end

function FlipIt(gear)

	if GetHogClan(gear) == 0 then
		HogTurnLeft(gear, true)
	else
		HogTurnLeft(gear, false)
	end

end

function onNewTurn()

	if GetHogClan(CurrentHedgehog) == 0 then
		SetWind(100)
	else
		SetWind(-100)
	end

	--InputMaskThatGuy()
	runOnHogs(FlipIt)

end

function onGameTick()

	if CurrentHedgehog ~= nil then

		CheckTeleporters()

		if GetCurAmmoType() ~= amGirder then
			InputMaskThatGuy()
		else
			SetInputMask(0xFFFFFFFF)
		end

		--if band(GetState(CurrentHedgehog),gstHHChooseTarget) ~= 0 then
		--	AddCaption("Helloooo")
		--end

	end

	ManageTeleporterEffects()

end

function onAmmoStoreInit()
	SetAmmo(amBazooka, 1, 0, 0, 0)
	SetAmmo(amGrenade, 2, 0, 0, 0)
	SetAmmo(amClusterBomb, 1, 0, 0, 0)
	SetAmmo(amFirePunch, 1, 0, 0, 0)
	SetAmmo(amGirder, 2, 0, 0, 0)
	SetAmmo(amParachute, 1, 0, 0, 0)
	SetAmmo(amSwitch, 9, 0, 0, 0)
	SetAmmo(amLowGravity, 1, 0, 0, 0)
	SetAmmo(amSkip, 9, 0, 0, 0)
end

function onGearDelete(gear)

	--if GetGearType(gear) == gtGirder then
	--	--AddCaption("girder rem")
	--end

	if GetGearType(gear) ~= gtFlake then
		trackDeletion(gear)
	end

end

function onGearAdd(gear)

	--if GetGearType(gear) == gtGirder then
		--AddCaption("girder add")
	--	InputMaskThatGuy()
	--end

	if GetGearType(gear) ~= gtFlake then
		trackGear(gear)
	end

	if GetGearType(gear) == gtHedgehog then
		hhs[numhhs] = gear
		numhhs = numhhs + 1
	end

	if GetGearType(gear) == gtFlake then
		DeleteGear(gear)
	end

end
